import axios from 'axios';
import { config } from '../../config';
const base = "http://localhost:" + config.internal_port

let access_token;
let axios_config;

beforeAll(async () => {
    jest.setTimeout(20000);
    const res = await axios.post(base + '/api/auth/login', { username: "demo", password: "demo" });
    access_token = res.data["access_token"];
    axios_config = {
        headers: { "authorization": "Bearer " + access_token },
        validateStatus: undefined
    };
});

// ---------------
describe('adding org', () => {
    let added_org;
    let added_org_id;
    let added_team;
    let added_team_id
    it('creating a new org with just a name should return 200', async () => {
        const res1 = await axios.post(base + '/api/organizations', {
            "name": "test123"
        }, axios_config);
        added_org = res1.data;
        added_org_id = added_org.id;
        expect(res1.status).toEqual(200);
        expect(res1.headers['content-type']).toContain("application/json")
    });
    it('creating a new team with a valid org should return 200', async () => {
        const res2 = await axios.post(base + '/api/teams', {
            "name": "test123",
            "parentGroup": added_org_id
        }, axios_config);
        added_team = res2.data;
        added_team_id = added_team.id;
        expect(res2.status).toEqual(200);
        expect(res2.headers['content-type']).toContain("application/json")
    });
    it('delete team', async () => {
        const res2 = await axios.delete(base + '/api/teams/' + added_team_id, axios_config);
        expect(res2.status).toEqual(200);
        expect(res2.headers['content-type']).toContain("application/json")
        let deleted_team = res2.data
        delete deleted_team.id;
        delete deleted_team.parentGroup;
        expect(deleted_team).toEqual({
            "name": "test123",
            "responseType": "RUNNERTEAM"
        });
    });
    it('check if team really was deleted', async () => {
        const res3 = await axios.get(base + '/api/teams/' + added_team_id, axios_config);
        expect(res3.status).toEqual(404);
        expect(res3.headers['content-type']).toContain("application/json")
    });
});
// ---------------
describe('adding + deletion (non-existant)', () => {
    it('delete', async () => {
        const res2 = await axios.delete(base + '/api/teams/0', axios_config);
        expect(res2.status).toEqual(204);
    });
});
